import _regeneratorRuntime from "babel-runtime/regenerator";

var _this = this;

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

/**
 * @jest-environment node
 */

import React from "react";
import { applyMiddleware, createStore as _createStore } from "redux";
import promiseMiddleware from "redux-promise-middleware";
import renderer from "react-test-renderer";
import wrapper from "./index";

var makeStore = function makeStore(initialState) {
    return _createStore(function (s) {
        return s;
    }, initialState, applyMiddleware(promiseMiddleware()));
};

describe('createStore', function () {
    describe('On the server', function () {
        test('should create new store for server each time', _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee() {
            var mock, App, WrappedApp, component;
            return _regeneratorRuntime.wrap(function _callee$(_context) {
                while (1) {
                    switch (_context.prev = _context.next) {
                        case 0:
                            mock = jest.fn().mockReturnValue(makeStore({}));

                            App = function App(_ref2) {
                                var foo = _ref2.foo;
                                return React.createElement(
                                    "div",
                                    null,
                                    foo
                                );
                            };

                            WrappedApp = wrapper(mock)(App);
                            component = renderer.create(React.createElement(WrappedApp, { store: makeStore({}) }));
                            _context.next = 6;
                            return WrappedApp.getInitialProps({
                                req: {}
                            });

                        case 6:
                            expect(component.toJSON()).toMatchSnapshot();
                            _context.next = 9;
                            return WrappedApp.getInitialProps({
                                req: {}
                            });

                        case 9:
                            expect(mock).toHaveBeenCalledTimes(2);

                        case 10:
                        case "end":
                            return _context.stop();
                    }
                }
            }, _callee, _this);
        })));

        test('setup store on server and use next.js page context params', _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee2() {
            var App, WrappedApp, component;
            return _regeneratorRuntime.wrap(function _callee2$(_context2) {
                while (1) {
                    switch (_context2.prev = _context2.next) {
                        case 0:
                            App = function App(_ref4) {
                                var foo = _ref4.foo;
                                return React.createElement(
                                    "div",
                                    null,
                                    foo
                                );
                            };

                            WrappedApp = wrapper({
                                createStore: function createStore(initialState, options) {
                                    expect(options.isServer).toBe(true);
                                    expect(options.query).toBeDefined();
                                    expect(options.req).toBeDefined();
                                    return _createStore(function (s) {
                                        return s;
                                    }, initialState, applyMiddleware(promiseMiddleware()));
                                }
                            })(App);
                            component = renderer.create(React.createElement(WrappedApp, { store: makeStore({}) }));
                            _context2.next = 5;
                            return WrappedApp.getInitialProps({
                                req: {},
                                query: {}
                            });

                        case 5:
                            expect(component.toJSON()).toMatchSnapshot();

                        case 6:
                        case "end":
                            return _context2.stop();
                    }
                }
            }, _callee2, _this);
        })));
    });
});