import _regeneratorRuntime from "babel-runtime/regenerator";

var _this3 = this;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var verifyComponent = function () {
    var _ref3 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee(WrappedPage) {
        var props, component, tree;
        return _regeneratorRuntime.wrap(function _callee$(_context) {
            while (1) {
                switch (_context.prev = _context.next) {
                    case 0:
                        _context.next = 2;
                        return WrappedPage.getInitialProps();

                    case 2:
                        props = _context.sent;


                        expect(props.initialProps.custom).toBe('custom');
                        expect(props.initialState.reduxStatus).toBe('foo');

                        // this is called by Next.js
                        component = renderer.create(React.createElement(WrappedPage, props));
                        tree = component.toJSON();

                        expect(tree).toMatchSnapshot();

                    case 8:
                    case "end":
                        return _context.stop();
                }
            }
        }, _callee, this);
    }));

    return function verifyComponent(_x2) {
        return _ref3.apply(this, arguments);
    };
}();

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React from "react";
import { applyMiddleware, createStore as _createStore } from "redux";
import promiseMiddleware from "redux-promise-middleware";
import renderer from "react-test-renderer";
import wrapper from "./index";

var reducer = function reducer() {
    var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : { reduxStatus: 'init' };
    var action = arguments[1];

    switch (action.type) {
        case 'FOO': // sync
        case 'FOO_FULFILLED':
            // async
            return { reduxStatus: action.payload };
        default:
            return state;
    }
};

var makeStore = function makeStore(initialState) {
    return _createStore(reducer, initialState, applyMiddleware(promiseMiddleware()));
};

var SyncPage = function (_React$Component) {
    _inherits(SyncPage, _React$Component);

    function SyncPage() {
        _classCallCheck(this, SyncPage);

        return _possibleConstructorReturn(this, (SyncPage.__proto__ || Object.getPrototypeOf(SyncPage)).apply(this, arguments));
    }

    _createClass(SyncPage, [{
        key: "render",
        value: function render() {
            return React.createElement(
                "div",
                null,
                React.createElement(
                    "div",
                    { className: "redux" },
                    this.props.reduxStatus
                ),
                React.createElement(
                    "div",
                    { className: "custom" },
                    this.props.custom
                )
            );
        }
    }], [{
        key: "getInitialProps",
        value: function getInitialProps(_ref) {
            var store = _ref.store;

            store.dispatch({ type: 'FOO', payload: 'foo' });
            return { custom: 'custom' };
        }
    }]);

    return SyncPage;
}(React.Component);

function someAsyncAction() {
    return {
        type: 'FOO',
        payload: new Promise(function (res) {
            res('foo');
        })
    };
}

var AsyncPage = function (_SyncPage) {
    _inherits(AsyncPage, _SyncPage);

    function AsyncPage() {
        _classCallCheck(this, AsyncPage);

        return _possibleConstructorReturn(this, (AsyncPage.__proto__ || Object.getPrototypeOf(AsyncPage)).apply(this, arguments));
    }

    _createClass(AsyncPage, null, [{
        key: "getInitialProps",
        value: function getInitialProps(_ref2) {
            var store = _ref2.store;

            var action = someAsyncAction();
            store.dispatch(action);
            return action.payload.then(function (payload) {
                return { custom: 'custom' };
            });
        }
    }]);

    return AsyncPage;
}(SyncPage);

test('simple store integration', _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee2() {
    var WrappedPage;
    return _regeneratorRuntime.wrap(function _callee2$(_context2) {
        while (1) {
            switch (_context2.prev = _context2.next) {
                case 0:
                    WrappedPage = wrapper(makeStore, function (state) {
                        return state;
                    })(SyncPage);
                    _context2.next = 3;
                    return verifyComponent(WrappedPage);

                case 3:
                case "end":
                    return _context2.stop();
            }
        }
    }, _callee2, _this3);
})));

test('async store integration', _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee3() {
    var WrappedPage;
    return _regeneratorRuntime.wrap(function _callee3$(_context3) {
        while (1) {
            switch (_context3.prev = _context3.next) {
                case 0:
                    WrappedPage = wrapper(makeStore, function (state) {
                        return state;
                    })(AsyncPage);
                    _context3.next = 3;
                    return verifyComponent(WrappedPage);

                case 3:
                case "end":
                    return _context3.stop();
            }
        }
    }, _callee3, _this3);
})));

var spyLog = jest.spyOn(global.console, 'log');

describe('createStore', function () {
    beforeEach(function () {
        spyLog.mockReset();
    });

    afterEach(function () {
        delete window.__NEXT_REDUX_STORE__;
    });

    test('simple props', function () {
        var App = function App(_ref6) {
            var foo = _ref6.foo;
            return React.createElement(
                "div",
                null,
                foo
            );
        };
        var WrappedApp = wrapper(makeStore, function (state) {
            return state;
        })(App);
        var component = renderer.create(React.createElement(WrappedApp, { foo: "foo" }));
        expect(component.toJSON()).toMatchSnapshot();
    });

    test('advanced props', function () {
        var App = function App(_ref7) {
            var foo = _ref7.foo;
            return React.createElement(
                "div",
                null,
                foo
            );
        };
        var WrappedApp = wrapper({ createStore: makeStore, mapStateToProps: function mapStateToProps(state) {
                return state;
            } })(App);
        var component = renderer.create(React.createElement(WrappedApp, { foo: "foo" }));
        expect(component.toJSON()).toMatchSnapshot();
    });

    test('debug mode from options', _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee4() {
        var App, WrappedApp, component;
        return _regeneratorRuntime.wrap(function _callee4$(_context4) {
            while (1) {
                switch (_context4.prev = _context4.next) {
                    case 0:
                        App = function App(_ref9) {
                            var foo = _ref9.foo;
                            return React.createElement(
                                "div",
                                null,
                                foo
                            );
                        };

                        WrappedApp = wrapper({
                            createStore: function createStore(initialState, options) {
                                expect(options.debug).toBe(true);
                                return _createStore(reducer, initialState, applyMiddleware(promiseMiddleware()));
                            },
                            debug: true
                        })(App);
                        component = renderer.create(React.createElement(WrappedApp, null));
                        _context4.next = 5;
                        return WrappedApp.getInitialProps();

                    case 5:
                        expect(spyLog).toHaveBeenCalledTimes(3);
                        expect(component.toJSON()).toMatchSnapshot();

                    case 7:
                    case "end":
                        return _context4.stop();
                }
            }
        }, _callee4, _this3);
    })));

    test('debug mode with setDebug method', _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee5() {
        var App, WrappedApp, component;
        return _regeneratorRuntime.wrap(function _callee5$(_context5) {
            while (1) {
                switch (_context5.prev = _context5.next) {
                    case 0:
                        App = function App(_ref11) {
                            var foo = _ref11.foo;
                            return React.createElement(
                                "div",
                                null,
                                foo
                            );
                        };

                        wrapper.setDebug(true);
                        WrappedApp = wrapper(function (initialState, options) {
                            expect(options.debug).toBe(true);
                            return _createStore(reducer, initialState, applyMiddleware(promiseMiddleware()));
                        })(App);
                        component = renderer.create(React.createElement(WrappedApp, null));
                        _context5.next = 6;
                        return WrappedApp.getInitialProps();

                    case 6:
                        expect(spyLog).toHaveBeenCalledTimes(3);
                        expect(component.toJSON()).toMatchSnapshot();

                    case 8:
                    case "end":
                        return _context5.stop();
                }
            }
        }, _callee5, _this3);
    })));

    test('should throw if no createStore method', _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee6() {
        var App;
        return _regeneratorRuntime.wrap(function _callee6$(_context6) {
            while (1) {
                switch (_context6.prev = _context6.next) {
                    case 0:
                        App = function App(_ref13) {
                            var foo = _ref13.foo;
                            return React.createElement(
                                "div",
                                null,
                                foo
                            );
                        };

                        expect(function () {
                            return wrapper({
                                debug: true
                            })(App);
                        }).toThrow();

                    case 2:
                    case "end":
                        return _context6.stop();
                }
            }
        }, _callee6, _this3);
    })));

    test('should be able to configure store key on window', _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee7() {
        var App, WrappedApp, component;
        return _regeneratorRuntime.wrap(function _callee7$(_context7) {
            while (1) {
                switch (_context7.prev = _context7.next) {
                    case 0:
                        App = function App(_ref15) {
                            var foo = _ref15.foo;
                            return React.createElement(
                                "div",
                                null,
                                foo
                            );
                        };

                        WrappedApp = wrapper({
                            createStore: makeStore,
                            storeKey: 'TESTKEY'
                        })(App);
                        component = renderer.create(React.createElement(WrappedApp, null));
                        _context7.next = 5;
                        return WrappedApp.getInitialProps();

                    case 5:
                        expect(window.__NEXT_REDUX_STORE__).not.toBeDefined();
                        expect(window.TESTKEY).toBeDefined();
                        expect(component.toJSON()).toMatchSnapshot();
                        delete window.TESTKEY;

                    case 9:
                    case "end":
                        return _context7.stop();
                }
            }
        }, _callee7, _this3);
    })));

    test('should memoize store on client in window', _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee8() {
        var App, App1, App2;
        return _regeneratorRuntime.wrap(function _callee8$(_context8) {
            while (1) {
                switch (_context8.prev = _context8.next) {
                    case 0:
                        App = function App(_ref17) {
                            var foo = _ref17.foo;
                            return React.createElement(
                                "div",
                                null,
                                foo
                            );
                        };

                        App1 = wrapper(makeStore, function (state) {
                            return state;
                        })(App);

                        renderer.create(React.createElement(App1, null));
                        expect(window.__NEXT_REDUX_STORE__).toBeDefined();
                        App2 = wrapper(function (initialState, options) {
                            throw new Error('New store should not be created!');
                        }, function (state) {
                            return state;
                        })(App);

                        renderer.create(React.createElement(App2, { foo: "foo" }));
                        expect(window.__NEXT_REDUX_STORE__).toBeDefined();

                    case 7:
                    case "end":
                        return _context8.stop();
                }
            }
        }, _callee8, _this3);
    })));
});